<?php
/**
 * @version		$Id: modules.php 6140 2007-01-02 03:44:18Z eddiea $
 * @package		Joomla
 * @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * This is a file to add template specific chrome to module rendering.  To use it you would
 * set the style attribute for the given module(s) include in your template to use the style
 * for each given modChrome function.
 *
 * eg.  To render a module mod_test in the sliders style, you would use the following include:
 * <jdoc:include type="module" name="test" style="slider" />
 *
 * This gives template designers ultimate control over how modules are rendered.
 *
 * NOTICE: All chrome wrapping methods should be named: modChrome_{STYLE} and take the same
 * two arguments.
 */

require_once ( JPATH_THEMES.DS.'fw_stars'.DS.'lib'.DS.'php'.DS.'treemenu.php' );

/**
 * Module chrome for rendering the module in a menu image
 */
function modChrome_flatmenu($module, &$params, &$attribs)
{
	static $xmls;
	
	$user	= &JFactory::getUser();
  $menu = &buildTreeMenu($params);

	$xml = JFactory::getXMLParser('Simple');
	$xml->loadString($menu);
	$doc = &$xml->document;

	echo '<div id="fwstarsmenu" class="flatmenu fmargin' .$params->get('moduleclass_sfx') .'">';
  echo $doc->toString();
	echo '</div>';
	
	loadMenu();
}

/*
 * Module chrome for rendering the module in a customized way
 */
function modChrome_custom( $module, &$params, &$attribs ) {
    if (isset( $attribs['headerLevel'] )) 
    {
      $headerLevel = $attribs['headerLevel'];
    } else {
      $headerLevel = 3;
    }
 
    if (isset( $attribs['headerColor'] )) 
    {
      $headerColor = $attribs['headerColor'];
    } else {
      $headerColor = 'blue';
    }

    if ($params->get( 'moduleclass_sfx' ) != null)
    {
      echo '<div class="' .$params->get('moduleclass_sfx') .'">';
    } else {
      echo '<div class="usermodule">';
    }
 
    if ($module->showtitle) 
    {
      echo '<h' .$headerLevel .' class="' .$headerColor .'">' .$module->title .'</h' .$headerLevel .'>';
    }
 
    echo $module->content;
    
    echo '</div>';
  }
  
?>
